diff -rNU 10 ../httpd-2.2.12-o/configure ./configure
--- ../httpd-2.2.12-o/configure	2009-07-20 22:24:36.000000000 +0200
+++ ./configure	2012-01-17 14:41:10.000000000 +0100
@@ -766,20 +766,21 @@
 MOD_MIME_MAGIC_LDADD
 MOD_ENV_LDADD
 MOD_LOGIO_LDADD
 MOD_LOG_FORENSIC_LDADD
 MOD_LOG_CONFIG_LDADD
 MOD_LDAP_LDADD
 MOD_DEFLATE_LDADD
 MOD_CHARSET_LITE_LDADD
 MOD_SUBSTITUTE_LDADD
 MOD_FILTER_LDADD
+MOD_REQTIMEOUT_LDADD
 MOD_INCLUDE_LDADD
 MOD_EXT_FILTER_LDADD
 MOD_CASE_FILTER_IN_LDADD
 MOD_CASE_FILTER_LDADD
 MOD_EXAMPLE_LDADD
 MOD_ECHO_LDADD
 MOD_DUMPIO_LDADD
 MOD_BUCKETEER_LDADD
 MOD_DBD_LDADD
 MOD_MEM_CACHE_LDADD
@@ -1703,20 +1704,21 @@
   --enable-cache          dynamic file caching
   --enable-disk-cache     disk caching module
   --enable-mem-cache      memory caching module
   --enable-dbd            Apache DBD Framework
   --enable-bucketeer      buckets manipulation filter
   --enable-dumpio         I/O dump filter
   --enable-echo           ECHO server
   --enable-example        example and demo module
   --enable-case-filter    example uppercase conversion filter
   --enable-case-filter-in example uppercase conversion input filter
+  --enable-reqtimeout     Limit time waiting for request from client
   --enable-ext-filter     external filter module
   --disable-include       Server Side Includes
   --disable-filter        Smart Filtering
   --enable-substitute     response content rewrite-like filtering
   --disable-charset-lite  character set translation
   --enable-charset-lite   character set translation
   --enable-deflate        Deflate transfer encoding support
   --enable-ldap           LDAP caching and connection pooling services
   --disable-log-config    logging configuration
   --enable-log-forensic   forensic logging
@@ -10935,20 +10937,116 @@
 
   current_dir=filters
   modpath_current=modules/filters
   modpath_static=
   modpath_shared=
   test -d filters || $srcdir/build/mkdir.sh $modpath_current
   > $modpath_current/modules.mk
 
 
 
+  { $as_echo "$as_me:${as_lineno-$LINENO}: checking whether to enable mod_reqtimeout" >&5
+$as_echo_n "checking whether to enable mod_reqtimeout... " >&6; }
+    # Check whether --enable-reqtimeout was given.
+if test "${enable_reqtimeout+set}" = set; then :
+  enableval=$enable_reqtimeout;
+else
+  enable_reqtimeout=most
+fi
+
+    _apmod_extra_msg=""
+      if test "$module_selection" = "most" -a "$enable_reqtimeout" = "most"; then
+    _apmod_error_fatal="no"
+  else
+    _apmod_error_fatal="yes"
+  fi
+  if test "$enable_reqtimeout" = "static"; then
+    enable_reqtimeout=yes
+  elif test "$enable_reqtimeout" = "yes"; then
+    enable_reqtimeout=$module_default
+    _apmod_extra_msg=" ($module_selection)"
+  elif test "$enable_reqtimeout" = "most"; then
+    if test "$module_selection" = "most" -o "$module_selection" = "all"; then
+      enable_reqtimeout=$module_default
+      _apmod_extra_msg=" ($module_selection)"
+    elif test "$enable_reqtimeout" != "yes"; then
+      enable_reqtimeout=no
+    fi
+  elif test "$enable_reqtimeout" = "maybe-all"; then
+    if test "$module_selection" = "all"; then
+      enable_reqtimeout=$module_default
+      _apmod_extra_msg=" (all)"
+    else
+      enable_reqtimeout=no
+    fi
+  fi
+  if test "$enable_reqtimeout" != "no"; then
+            :
+  fi
+  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $enable_reqtimeout$_apmod_extra_msg" >&5
+$as_echo "$enable_reqtimeout$_apmod_extra_msg" >&6; }
+  if test "$enable_reqtimeout" != "no"; then
+    case "$enable_reqtimeout" in
+    shared*)
+      enable_reqtimeout=`echo $enable_reqtimeout|sed 's/shared,*//'`
+      sharedobjs=yes
+      shared=yes
+      DSO_MODULES="$DSO_MODULES reqtimeout"
+      ;;
+    *)
+      MODLIST="$MODLIST reqtimeout"
+      if test "reqtimeout" = "so"; then
+          sharedobjs=yes
+      fi
+      shared="";;
+    esac
+
+
+  if test -z ""; then
+    objects="mod_reqtimeout.lo"
+  else
+    objects=""
+  fi
+
+  if test -z "$module_standalone"; then
+    if test -z "$shared"; then
+      # The filename of a convenience library must have a "lib" prefix:
+      libname="libmod_reqtimeout.la"
+      BUILTIN_LIBS="$BUILTIN_LIBS $modpath_current/$libname"
+      modpath_static="$modpath_static $libname"
+      cat >>$modpath_current/modules.mk<<EOF
+$libname: $objects
+        \$(MOD_LINK) $objects \$(MOD_REQTIMEOUT_LDADD)
+EOF
+    else
+      apache_need_shared=yes
+      libname="mod_reqtimeout.la"
+      shobjects=`echo $objects | sed 's/\.lo/.slo/g'`
+      modpath_shared="$modpath_shared $libname"
+      cat >>$modpath_current/modules.mk<<EOF
+$libname: $shobjects
+        \$(SH_LINK) -rpath \$(libexecdir) -module -avoid-version  $objects \$(MOD_REQTIMEOUT_LDADD)
+EOF
+    fi
+  fi
+
+
+  APACHE_VAR_SUBST="$APACHE_VAR_SUBST MOD_REQTIMEOUT_LDADD"
+
+
+
+  fi
+
+
+
+
+
   { $as_echo "$as_me:$LINENO: checking whether to enable mod_ext_filter" >&5
 $as_echo_n "checking whether to enable mod_ext_filter... " >&6; }
     # Check whether --enable-ext-filter was given.
 if test "${enable_ext_filter+set}" = set; then
   enableval=$enable_ext_filter;
 else
   enable_ext_filter=most
 fi
 
     _apmod_extra_msg=""
diff -rNU 10 ../httpd-2.2.12-o/modules/filters/config.m4 ./modules/filters/config.m4
--- ../httpd-2.2.12-o/modules/filters/config.m4	2007-12-09 16:19:40.000000000 +0100
+++ ./modules/filters/config.m4	2012-01-17 14:41:29.000000000 +0100
@@ -1,16 +1,17 @@
 dnl modules enabled in this directory by default
 
 dnl APACHE_MODULE(name, helptext[, objects[, structname[, default[, config]]]])
 
 APACHE_MODPATH_INIT(filters)
 
+APACHE_MODULE(reqtimeout, Limit time waiting for request from client, , , most)
 APACHE_MODULE(ext_filter, external filter module, , , most)
 APACHE_MODULE(include, Server Side Includes, , , yes)
 APACHE_MODULE(filter, Smart Filtering, , , yes)
 APACHE_MODULE(substitute, response content rewrite-like filtering, , , most)
 
 if test "$ac_cv_ebcdic" = "yes"; then
 # mod_charset_lite can be very useful on an ebcdic system,
 #   so include it by default
     APACHE_MODULE(charset_lite, character set translation, , , yes)
 else